--$Name:Ночная прогулка$
--$Author:Peter Kosyh$
--$Info:Игра на ИНСТЕДОЗ 5$

require "fmt"
fmt.para = true
require "noinv"
require "nolife"
require "fmt"
dlg.noinv = true
dlg.nolife = true
game.pic = 'gfx/tree.png'

global 'enable_map' (false)

function scene(v)
	v.noinv = true
	v.nolife = true
	v.num = 1
	if type(v.decor) == 'string' then
		v.__decor = { v.decor }
	else
		v.__decor = v.decor
	end
	v.decor = function(s)
		return s.__decor[v.num]
	end
	v.obj = {
		obj { dsc = '{Дальше}';
		      act = function(s)
			      instead.need_fading(true)
			      v.num = v.num + 1;
			      if v.num > #v.__decor then
				      walk(v.next)
			      end
		      end
		}
	};
	return room(v)
end

function show_map()
	if not enable_map then
		return 'gfx/ship.png'
	end
	local dx = 340
	if rawget(_G, 'js') then
		dx = 6
	end
	local bg = 'gfx/ship.png;gfx/ship_map.png@'..std.tostr(dx)..',10'
	local coords = {
		['Внутри'] = { 26, 122 },
		['логово'] = { 26, 101 },
		['грузовой отсек'] = { 15, 60 },
		['инженерный отсек'] = { 36, 60 },
		['мостик'] = { 26, 23 },
	}
	local c = coords[std.nameof(here())]
	local x, y = c[1] - 2 + dx, c[2] - 2
	if here() ^ 'грузовой отсек' and hidden then
		x = x - 10
	end
	bg = bg ..';gfx/white_dot.png@c'..std.tostr(x)..','..std.tostr(y)
	local spider
	if seen 'паук' then spider = true end
	for k, v in ipairs(ways()) do
		if where 'паук' == v or 
			(v.walk and where 'паук' == std.ref (v.walk)) then
			if here() ^ 'логово' or where 'паук' == from() then
				spider = true
				break
			end
		end
	end
	if not spider then
		return bg
	end
	c = coords[std.nameof(where 'паук')]
	x, y = c[1] + 2 + dx, c[2] + 2
	bg = bg ..';gfx/red_dot.png@c'..std.tostr(x)..','..std.tostr(y)
	return bg
end

scene {
	nam = 'main';
	title = '';
	next = 'r2';
	decor = {
		[[С тех пор, как в НИИ появились военные, Петр не находил себе места.
Не смотря на то, что генерал вел себя подчеркнуто вежливо по отношению к работникам института
и того же требовал от своих солдат, Петр остро чувствовал что-то вроде нездоровой ревности.^^
Но если это чувство, которое теперь мешало ему работать, он еще мог в себе заглушить,
то обиду и гнев за ограничение свободы в исследованиях -- никогда!]];
		[[Последний раз, когда портал открылся снова и Валерка запустил в
него дрона, Петр намеревался сам пройти через загадочный переход и провести исследования.
Но его не пустили эти дуболомы генерала! Не пустили его -- Петра, в
собственной лаборатории!]],
		[[Письменное разрешение генерала, которое требовали солдафоны, удалось получить
только через несколько часов. Так как генерала срочно вызвали в Министерство обороны, и его не было
на месте. Но вскоре после этого, портал схлопнулся и Петр кусал от досады локти.]];
		[[Но такого больше не повторится! Петр взломал веб-камеру, установленную в лаборатории
и теперь круглосуточно следил за диском (остальные при этом наблюдали фотографию лаборатории).
Почти месяц цвет диска не менялся. Но сегодня ночью, наконец,
портал открылся. К счастью, это произошло в ночь на воскресенье, когда в институте дежурил только один
солдат. Петр был в опустевшем институте уже через несколько минут.]];
	};
}

room {
	nam = 'r2';
	title = 'Перед институтом';
	decor = [[Петр находится перед родным для него {#нии|НИИ}. Сейчас около 3 часов ночи.]];
	way = { path { 'К проходной', 'проходная' } };
}: with
{
	obj {
		nam = '#нии';
		act = [[Только в одном окне виден свет. Это лаборатория Петра. Там находится портал.]];
	};
}

obj {
	nam = 'пропуск';
	inv = function(s)
		p [[Магнитная карточка.]]
	end;
	use = function(s, w)
		if w^'#сторож' then
			if w.sleep then
				p [[Стоит ли будить сторожа?]]
			elseif here().pass then
				p [[-- Михалыч, у меня и пропуск есть! -- радостно сказал Петр. Михалыч не ответил.]];
			else
				p [[-- Михалыч, у меня пропуск есть!^-- Приказ генерала, никого не пускать ночью! -- буркнул Михалыч.]]
			end
			return
		elseif w^'#турникет' then
			if here().pass then
				p [[Путь свободен!]]
			else
				p [[Петр поднес пропуск к считывателю как это делал несчетное число раз. Но зеленая лампочка не загорелась.]]
			end
			return
		end
		p [[Пропуск тут не поможет.]]
	end;
}

room {
	nam = 'проходная';
	title = 'Проходная';
	pass = false;
	decor = [[Внутри проходной темно и тихо.]];
	enter = function(s, f)
		if f^'r2' then
			_'#сторож'.sleep = true
		end
	end;
	onexit = function(s, t)
		if s.pass then
			return
		end
		if t^'у кабинета' then
			if not _'#сторож'.sleep then
				return [[Михалыч неодобрительно смотрит на Петра.]], false
			end
			_'#сторож'.sleep = false
			p [[Петр попытался пролезть под турникетом, но больно стукнулся макушкой и непроизвольно высказал неудовольствие происходящим.]]
			p [[Высказывание разбудило сторожа.]]
			walkin 'сторож'
			return false
		end
	end;
	way = { path { 'На улицу', 'r2' }, path { 'В институт', 'у кабинета' } };
}: with
{
	obj {
		nam = '#турникет';
		act = function()
			if here().pass then
				p [[На турникете горит зеленая лампочка.]]
			else
				p [[В принципе, под турникетом можно пролезть.]]
			end
		end;
	};
	obj {
		nam = '#сторож';
		dsc = function(s)
			p [[В кабинке, перед {#турникет|турникетом},]]
			if s.sleep then
				p [[дремлет {сторож}.]]
			else
				p [[сидит {Михалыч}.]]
			end
		end;
		sleep = true;
		know = false;
		act = function(s)
			if here().pass then
				if s.sleep then
					s.sleep = false
					pn [[-- Михалыч, так можно мне пройти? -- крикнул Петр.]]
					p [[-- А, что? Да, конечно, будьте любезны, Петр Геннадьевич.]]
				else
					p [[-- Проходите, Петр Геннадьевич.]]
				end
				return
			end
			if s.sleep then
				s.sleep = false;
				pn [[-- Михалыч! Зачем-то громко крикнул Петр.]]
				pn [[-- Что, кто здесь?]];
				walkin 'сторож'
			else
				walkin 'сторож'
			end
		end;
	}
}
dlg {
	nam = 'сторож';
	title = 'Разговор с Михалычем';
	enter = function(s)
		if visited(s) then
			s:reset('#был')
		end
	end;
	dsc = [[Сторож Михалыч смотрит на Петра. В его сонных глазах читается вопрос.]];
	phr = {
		{ "Это я, Михалыч!", "-- Здравствуйте, Петр Геннадьевич!", next = '#2', },
		{ '#2', "Спи спокойно, Михалыч.", "-- Спасибо, Петр Геннадьевич, но я на службе!",
		  { 'Михалыч, мне нужно в свою лабораторию!',
		    '-- Мне очень жаль, Петр Геннадьевич, но приказ генерала -- никого ночью не пускать!',
		    { 'Ну пусти, ну мне очень надо!', '-- Не имею возможности нарушить указ генерала, Петр Геннадьевич!' },
		    { 'Михалыч, если ты меня не пустишь, я расскажу Сан Санычу, что ты спал на службе...',
		      function ()
			      seen('#сторож', 'проходная').know = true
			      p '-- Эх, и не совестно вам, Петр Геннадьевич? Я никогда не сплю на рабочем месте!'
			      walkout()
		      end,
		    },
		  },
		  { 'Как дела, Михалыч?', '-- Как сажа бела, Петр Генадьевич.' }
		},
		{ false, '#был',
		  { "Это же я, Михалыч! Пусти, а?", "-- Не имею возможности, Петр Геннадьевич -- приказ генерала." },
		  { cond = function() return _'мобильник'.photos end,
		  "Михалыч, у меня есть интересная фотка для тебя.", pfn(walkout) "-- Гм, ну покажите-ка, Петр Геннадьевич." },
		},
		{ false, '#пусти',
		  { 'Вот, Михалыч, посмотри фотку.', 'Сторож поправил очки и посмотрел на экран навороченного смартфона Петра.^ -- Ох, Петр Геннадьевич, да как же это возможно!',
		    {'Михалыч, мне очень нужно в лабораторию.',
		     [[Я сотру эти фотки, а ты не будешь говорить генералу о том, что я пришел поработать ночью, хорошо?^
-- Хорошо, Петр Генадьевич -- в голосе сторожа чувствуется обида -- но вы уж наверняка сотрите!]],
		     { 'Конечно, сотру, Михалыч!', function(s) p [[-- Проходите, Петр Геннадьевич!]]; _'проходная'.pass = true; walkout() end };
		    },
		    { 'Я выложу фотки в инстаграмм!', '-- Хм.. Сто грамм? Я не пью на работе -- с сожалением говорит Михалыч.' },
		  };
		},
	}
}
obj {
	nam = 'мобильник';
	photos = false;
	tak = function(s)
		if not here().light then
			return _'дверь1':act()
		end
		p [[Петр забрал мобильник.]];
	end;
	dsc = [[На полу около {дверь1|двери} лежит включенный {мобильник}.]];
	inv = function(s)
		if me() == cat then
			return [[Зачем это бедному Коту?]]
		end
		if idea then
			if idea == 2 then
				p [[Петр включил диктофон на запись: -- Это Петр, мне нужна срочная помощь!...^
Через несколько секунд Петр закончил диктовать. Он запрограммировал смартфон на отложенную отправку сообщения.]]
				idea = 3
				return
			end
			if idea == 3 then
				p [[Нужно закрепить смартфон на Гегеле!]];
				return
			end
			p [[Нужно найти способ выбраться из западни хотя бы Гегелю.]]
			return
		end
		if here() ^ 'В кабине' then
			return [[Нет сигнала.]]
		end
		if s.photos then
			p [[В галерее есть новые фотки спящего Михалыча.]]
		else
			p [[Навороченный китайский смартфон. Работает почти стабильно.]]
		end
	end;
	use = function(s, w)
		if me() == cat then
			return [[Вряд ли Гегель может применить мобильник.]]
		end
		if w^'#сторож' then
			if not w.sleep then
				if here().pass then
					p [[Не стоит лишний раз расстраивать Михалыча.]]
					return
				end
				if s.photos then
					walkin 'сторож'
					_'сторож':reset '#пусти'
					return
				end
				p [[-- Михалыч, можно тебя сфоткать?^-- Это еще зачем, Петр Геннадьевич? -- насторожился Михалыч.]]
				return
			end
			if not w.know then
				p [[Петр решил не звонить Михалычу.]]
				return
			end
			if s.photos then
				p [[Подумав, Петр стер фотки Михалыча и сделал несколько новых, гораздо лучших!]]
			else
				p [[Подумав, Петр сделал несколько снимков спящего Михалыча.]]
				p [[Залить что-ли в инстаграмм? -- Подумал Петр -- Но тогда у Михалыча могут быть проблемы...]];
				s.photos = true
			end
			return
		elseif w^'дверь1' then
			if seen 'щиток' and actions(w) > 0 then
				p [[Петр включил мобильник и положил его около двери в хозяйственное помещение.]]
				drop(s)
				return
			end
		elseif w^'#тьма' then
			p [[Петр посветил мобильником. Недалеко он заметил дверь.]]
			return
		elseif w^'кот2' then
			if not idea then
				idea = true
				p [[В голову Петру пришла идея.]]
			else
				if idea == 2 then
					p [[Сначала надо записать сообщение о помощи.]]
					return
				elseif idea == 3 then
					p [[Петр снял ремень и с его помощью закрепил смартфон на удивленном Гегеле.]]
					idea = 4
					remove(s)
					return
				else
					p [[Петр надеется, что идея сработает.]]
				end
			end
			p [[Для ее реализации нужно найти лаз для кота, чтобы он смог выбраться из западни!]]
			p [[Время дорого!]];
			return
		end
		p [[Мобильник тут не поможет.]]
	end;
}

room {
	nam = 'у кабинета';
	light = true;
	title = '5-й этаж';
	first = false;
	life = function(s)
		if not s.first then
			s.first = true
			return
		end
		lifeoff(s)
		s.first = false
		s.light = true
		enable '#свет'
		enable 'щиток'
		disable '#тьма'
		enable 'дверь1'
		p [[Солдат приближался. Он шел к щитку. Все, что оставалось Петру это спуститься на 4-й этаж и подождать,
пока солдат не включит свет и вернется на свой пост. Петр снова поднялся на пятый этаж.]];
		return true
	end;
	enter = function(s, f)
		if f^'проходная' then
			p [[В институте было темно, но Петр боялся включать свет. Он быстро и бесшумно (если
не считать проклятого ведра между вторым и третьим этажами) поднялся на пятый этаж, где располагалась
его лаборатория...]]
		end
	end;
	decor = function(s)
		if s.light then
			p [[Петр находится в коридоре пятого этажа. Прямо за {#угол|углом} находится лаборатория.
В коридоре горит {#свет|свет}. Рядом в стене есть {дверь1|дверь}.]];
		else
			p [[Петр находится в абсолютной {#тьма|темноте}. Где-то за {#угол|углом} стены находится лаборатория.]];
		end
	end;
--	way = { path { 'В лабораторию', 'лаборатория' } };
}
:with
{
	obj {
		nam = '#тьма';
		act = [[Хоть глаз выколи!]];
	}:disable();
	obj {
		nam = 'дверь1';
		act = function(s)
			if here().light then
				p [[Петр осторожно приоткрыл дверь. Это было хозяйственное помещение. Кроме ведра с грязной тряпкой -- ничего интересного.]];
			else
				take 'мобильник'
				lifeoff(here())
				walk 'lab-scene'
				return
			end
		end;
	};
	obj {
		nam = '#свет';
		act = function(s)
			p [[Тусклый свет флуоресцентных ламп очень неприятен Петру.]]
			if actions '#угол' > 0 then
				p [[Петру зачем-то приходит мысль,
что на каждом этаже института есть щиток.]];
				enable 'щиток'
			end
		end;
	};
	obj {
		nam = '#угол';
		act = function(s)
			if here().light then
				p [[Петр осторожно выглянул из-за угла. У двери лаборатории стоит солдат. Нужно что-то придумать.]];
			else
				p [[Петр подошел к углу и прислушался. Он услышал звук приближающихся шагов!]];
			end
		end;
	};
	obj {
		nam = 'щиток';
		dsc = [[Возле лифта на этаже находится электрический {щиток}.]];
		act = function(s)
			here().light = false
			disable '#свет'
			pn [[Петр тихо подошел к щитку, открыл его и выключил автомат. Коридор погрузился во тьму.]]
			p [[-- Опять автоматы не выдержали, гражданские ... (дальше неразборчиво) -- услышал Петр недовольный голос солдата из-за угла.]];
			disable (s)
			enable '#тьма'
			if not seen 'мобильник' then
				disable 'дверь1'
			end
			lifeon(here())
		end;
	}:disable();
}
scene {
	nam = 'lab-scene';
	title = '';
	next = 'Лаборатория';
	decor = {
		[[Благодаря своей находчивости, Петр точно знал где находится хозяйственное помещение.
Он бесшумно забрался в каморку, предварительно подняв мобильник с пола.]];
		[[Затем он подождал, пока солдат не пройдет мимо, по направлению к щитку. И так же бесшумно
вылез из каморки и завернул за угол. Перед ним была дверь лаборатории. В этот момент загорелся свет.]],
		[[Время было дорого! Петр прислонил пропуск к двери... Половина секунды тянулась вечность,
но вот -- Петр уже внутри лаборатории!]];
	}
}

game.onact = function(s, w)
	if here()^'Лаборатория' then
		if _'#холодильник'.portal then
			if not (w ^'#холодильник') then
				p [[Петра сейчас интересует только портал!]]
				return false
			end
		end
		return
	end
	if here().onact then
		return std.call(here(), 'onact', w)
	end
	if seen 'паук' and _'паук'.attack then
		p [[Паук вот-вот нападет! Нужно бежать!]]
		return false
	end
	return
end
room {
	nam = 'Лаборатория';
	portal = false;
	decor = [[Петр внутри лаборатории. Глаза уже успели привыкнуть к темноте и Петр различает
{#диск|артефакт}, который лежит на одном из {#стол|столов}. В {#окна|окна} лаборатории тускло льется звездный свет.
]];
}: with {
	obj {
		nam = '#диск';
		act = function(s)
			if s:actions() == 0 then
				p [[Странно, но Петр не обнаружил проволочной рамки у артефакта.]]
			end
			p [[Артефакт в форме диска медленно пульсирует. В темноте это хорошо заметно. Где-то рядом должен быть
портал. Надо его найти!]]
			here().portal = true
		end;
	};
	obj {
		nam = '#стол';
		act = function()
			if here().portal then
				p [[Петр поискал портал под столами, но не обнаружил его.]]
			else
				p [[В лаборатории несколько больших столов.]]
				return
			end
			if not seen 'кот' then
				p [[Под столом Петр заметил два зеленых огонька.]]
				enable 'кот'
			end
		end;
	};
	obj {
		nam = '#окна';
		act = function()
			if here().portal then
				p [[В прошлый раз портал открылся в одном из окон. Но сейчас его здесь нет.]]
			else
				p [[За окнами ночь.]]
			end
		end;
	};
	obj {
		nam = '#холодильник';
		seen = false;
		portal = false;
		dsc = function(s)
			if s.seen then
				p [[В углу стоит {холодильник}.]]
			else
				return false
			end
		end;
		act = function(s)
			if s.seen and not seen 'лоток' then
				p [[Петр пошел к холодильнику и почти сразу на что-то наступил. Это был лоток Гегеля.]]
				enable 'лоток';
				return
			end
			if s.portal then
				walk 'В портал'
				return
			end
			if s.seen then
				s.portal = true
				p [[Петр подошел к огромному холодильнику. Дверь холодильника была открыта. Это показалось Петру странным,
так как Гегель обычно закрывал за собой дверь. Но еще более странным было то, что за дверью холодильника ничего не было! Только
серебристая рябь пространства, едва различимая в темноте. Вот он, портал! -- понял Петр.]];
				return
			end
			if here().portal then
				s.seen = true;
				p [[Петр решил осмотреть холодильник, о существовании которого он совсем забыл. Холодильник находился в дальнем углу лаборатории.]]
			else
				p [[Петру не хочется есть.]]
			end
		end;
	};
	obj {
		nam = 'кот';
		know = false;
		dsc = function(s)
			if s.know then
				p [[Под столом Петр видит {Гегеля}.]];
			else
				p [[Под столом Петр видит два зеленых {огонька}.]];
			end
		end;
		act = function(s)
			if _'#холодильник'.seen then
				p [[Гегель выглядит недовольным.]]
				return
			end
			if s:actions() <= 2 then
				if s:actions() == 0 then
					p [[Может не надо?]]
				elseif s:actions() == 1 then
					p [[А вдруг это опасно?]]
				elseif s:actions() == 2 then
					p [[Может быть, стоит сначала сохраниться?]]
				end
				return
			end
			s.know = true
			enable '#рамка'
			p [[Петр осторожно подошел к столу и опустился на корточки. Уффф! Это же Гегель! Лабораторный кот! Правда, обычно он ошивается около {#холодильник|холодильника}.
Он может свободно входить и выходить из лаборатории через специальную дверцу в двери.
Рядом с котом Петр заметил смятую проволочную рамку.]];
		end;
	}:disable();
	obj {
		nam = '#рамка';
		dsc = [[Возле Гегеля валяется проволочная {рамка}.]];
		act = [[Если бы не Гегегль, портал открылся бы в проволочной рамке, которая специально
была установлена здесь. Похоже, коту рамка не понравилась. Нужно будет запретить ему вход в лабораторию.]]
	}:disable();
	obj {
		nam = 'лоток';
		dsc = [[Рядом с Петром валяется опрокинутый {лоток}.]];
		act = [[Этот лоток служит для Гегеля туалетом. Уберу когда вернусь -- подумал Петр.]];
	}:disable();
}
cat = player { nam = 'Гегель', room = 'дерево' }

scene {
	nam = 'В портал';
	title = '';
	next = 'дерево';
	decor = {
		[[Петр исчез в холодильнике...]];
		[[... Гегель был зол. Сначала пропала вкусная еда из холодильника. Потом Петр не покормил Гегеля, и вместо этого пропал в холодильнике.
А потом настал длинный и скучный день, когда в лаборатории никого нет, и нет еды в холодильнике.]],
		[[Когда стало совсем светло, Гегель взобрался на подоконник и начал смотреть в окно. Но никто
не приходил. Время тянулось медленно. За окном пошел дождь. Гегель просидел на подоконнике до конца дня.]];
		[[Ночь. Петр все не возвращался из холодильника. Кажется кто-то идет! Нет, это шум дождя. Бедный Гегель не доживет до следующего дня.
Бедный Гегель умрет с голоду. Нужно вернуть Петра, чтобы он покормил Гегеля. Но холодильник страшный!]];
		fmt.em [[Гегель будет терпеть до утра!]];
		fmt.em [[Гегель будет терпеть до утра!!]];
		fmt.em [[Гегель будет терпеть до утра!!!]];
		fmt.em [[Гегель идет за Петром в холодильник!!!!]];
	};
	exit = function(s)
		change_pl(cat)
	end;
}

room {
	nam = 'дерево';
	onact = function(s)
		return _'Озеро':onact()
	end;
	title = [[У дерева]];
	onexit = function(s, w)
		if w ^'Лаборатория' then
			if seen 'чайка' then
				disable '#наверх'
				walk 'Повтор'
				lifeoff 'чайка'
				remove 'чайка'
				return false
			end
			if idea then
				walk 'happyend'
				return false
			end
			p [[Гегелю надо найти человека.]]
			return false
		end
	end;
	enter = function(s, f)
		if f ^ 'В портал' then
			p [[Звуки. Запахи. Свет. Гегель был сбит с толку, ведь только что была ночь, а теперь снова вечер. Странный холодильник.]];
		end;
	end;
	decor = [[Гегель находится на холме. Рядом стоит старый {#дуб|дуб}. Холм и луг под холмом покрыт зеленой {#трава|травой}. Еще дальше
Гегель видит огромное плоское {#озеро|озеро}, которое искрится в лучах заходящего {#солнце|солнца}. Прохладный {#ветер|ветерок} обдувает Гегеля.]];
	way = { path {'#в дупло', 'В дупло', 'Лаборатория'}:disable(),
		path { '#к озеру', 'К озеру', 'Озеро'}:disable(),
		path { '#наверх', 'Наверх', 'На дереве'}:disable(),
		path { 'В лес', 'В лес', 'Лес'}:disable()};
}:with {
	obj {
		nam = '#дуб';
		tree = false;
		act = function(s)
			if not seen '#портал' then
				enable '#портал'
				enable '#в дупло'
			end
			if seen 'чайка' then
				s.tree = true
			end
			if s.tree then
				enable '#наверх'
				p [[Гегель подумал, что смог бы забраться на дерево.]]
			else
				p [[Гегель видит в дубе огромное дупло. Через это дупло Гегель попал сюда.]]
			end
		end;
	};
	obj {
		nam = '#озеро';
		act = function(s)
			p [[Со стороны озера доносится запах рыбы.]];
			enable '#к озеру'
		end;
	};
	obj {
		nam = '#трава';
		act = [[Травинки едва заметно шевелятся. Гегель слышит как они шелестят.]];
	};
	obj {
		nam = '#солнце';
		act = [[Красное солнце скоро зайдет за горизонт.]];
	};
	obj {
		nam = '#ветер';
		act = function(s)
			p [[Гегель чувствует разные запахи. Но запаха человека -- нет.]]
		end;
	};
	obj {
		nam = '#портал';
		dsc = [[В дубе зияет огромное {дупло}.]];
		act = function()
			p [[Гегелю не нравится это дупло.]];
		end;
	}:disable();
}

room {
	nam = 'Озеро';
	onact = function(s)
		if seen 'чайка' and _'чайка'.step >= 2 then
			p [[Гегелю нужно скрыться от чайки!]]
			return false
		end
	end;
	enter = function(s)
		if not _'медведь'.attack then
			_'чайка'.step = 0
			lifeon 'чайка'
		end
	end;
	decor = [[Гегель слышит, как волны большого {#озеро|озера} накатываются на берег.
Над озером кружат {#чайки|чайки}.]];
	way = { path { 'К дубу', 'дерево'} };
}: with {
	obj {
		nam = '#озеро';
		act = [[Пахнет рыбой и водорослями, но рыба в воде. Человека здесь тоже нет.]];
	};
	obj {
		nam = '#чайки';
		act = function()
			p [[Их пронзительный крик разносится по озеру.]]
		end;
	};
}
obj {
	nam = 'чайка';
	step = 0;
	act = function(s)
		if live(s) then
			p [[Гегель понимает, что это птица, но чайка кажется огромной. И еще она пронзительно кричит!]];
			return
		end
		p [[Чайка не сдается! Она кружит во круг медведя и клюет его!]]
	end;
	dsc = function(s)
		if not live(s) then
			return
		end
		if s.step < 2 then
			p [[Гегель видит, как одна крупная {чайка} летит к нему.]]
		else
			p [[{Чайка} совсем рядом! Ее пронзительный крик пугает Гегеля. Она собирается атаковать!]]
		end
	end;
	life = function(s)
		if player_moved() then
			s.step = 0
		end
		place(s)
		s.step = s.step + 1
		if seen 'медведь' then
			_'медведь'.attack = true
			lifeoff(s)
			p [[Чайка потеряла интерес к Гегелю и набросилась на медведя!]]
			return true
		end
	end;
}

room {
	nam = 'На дереве';
	enter = function()
		if live 'чайка' then
			lifeoff 'чайка'
			remove 'чайка';
			p [[Гегель кое-как забрался на дуб и затаился в старых узловатых ветвях.
Чайка еще некоторое время покружила вокруг дерева, пугая кота, но потом все-таки улетела обратно в сторону озера.]]
		else
			p [[Гегель кое-как забрался на дуб.]]
		end
	end;
	decor = [[Гегель находится на дереве. Он прячется между толстыми узловатыми {#ветки|ветками}.]];
	obj = {
		obj {
			nam = '#ветки';
			act = [[Пахнет дубом.]];
		};
	};
	way = { path { 'Вниз', 'дерево' }, path { 'Вверх', 'высоко'} };
}

room {
	nam = 'высоко';
	title = 'Еще выше';
	enter = [[Гегель попробовал взобраться повыше. И ему это удалось!]];
	decor = [[Гегель забрался высоко. Усы Гегеля дрожат по дуновением ветра.
Отсюда открывается прекрасный {#вид|вид}.]];
	way = { path { 'На землю', 'дерево' } };
}: with {
	obj {
		nam = '#вид';
		act = function()
			enable '#корабль';
			p [[Гегель видит лес. Еще Гегель видит нечто странное.]];
		end
	};
	obj {
		nam = '#корабль';
		dsc = [[Гегель видит что-то {странное} в лесу.]];
		act = function()
			p [[Гегель видит, что часть деревьев повалены и среди них
в землю врыта какая-то громадина. Она выглядит так, как будто ее сделали люди.
Гегель думает, что там может быть человек.]];
			enable 'В лес'
			game.pic = 'gfx/ship.png';
		end;
	}:disable();
}
scene {
	nam = 'Повтор';
	tilte = 'Бегство';
	next = 'дерево';
	decor = {
		[[Гегель бросился в дупло. Через мгновенье он вылетел из холодильника в лабораторию.
Здесь все было по-прежнему. По стеклу текли капли дождя, а холодильник был пуст...]];
		[[Гегель не мог успокоиться, он ходил из стороны в сторону по подоконнику глядя на улицу.]];
		[[Наконец, он не выдержал, и снова бросился к холодильнику...]];
	};
}

obj {
	nam = 'медведь';
	attack = false;
	act = function(s)
		p [[Медведь разъярен и не обращает внимания на Гегеля.]]
	end;
	dsc = function(s)
		if s.attack then
			p [[Гегель видит как {медведь} борется с {чайка|чайкой}.]]
		else
			p [[Огромный {медведь} встал на задние лапы и надвигается на Гегеля!]];
		end
	end;
}

room {
	nam = 'Лес';
	enter = function(s, f)
		if f ^ 'дерево' then
			p [[Гегель устремился в сторону леса.]]
		end
	end;
	onact = function(s)
		if seen 'медведь' and not _'медведь'.attack then
			p [[Медведь может разорвать Гегеля. Надо бежать!]]
			return false
		end
	end;
	decor = [[Гегель видит поваленные {#деревья|деревья}. Странная {#громада|громада} возвышается
над котом.]];
	way = { path { 'Внутрь', 'Внутри' }, path { 'На холм', 'дерево' } };
}:with {
	obj {
		nam = '#деревья';
		act = [[Их повалила эта громада? Может быть, она упала на них?]];
	};
	obj {
		nam = '#громада';
		act = function(s)
			p [[Громада пугает Гегеля. Но ему кажется, что где еще быть человеку, как не внутри?]];
			if not s.attack and not seen 'медведь' then
				place 'медведь'
				p [[Гегель начал осматривать громаду, когда вдруг раздался треск и из лесной чащи вышел медведь.]]
				return
			end
			if disabled 'Внутри' then
				p [[Гегель видит проход внутрь.]]
				enable 'Внутри'
			end
		end;
	};
}

room {
	nam = 'Внутри';
	pic = show_map;
	onenter = function(s, f)
		if f ^ 'Лес' and idea then
			p [[Кот не хочет больше встречаться с пауком.]]
			return false
		end
	end;
	enter = function(s, f)
		if f ^ 'Лес' or f ^ 'тоннель' then
			lifeon 'паук'
		end
	end;
	onexit = function(s, t)
		if t ^ 'Лес' and seen 'паутина' then
			p [[Выход затянут крепкой и липкой паутиной!]]
			return false
		end
	end;
	exit = function(s, t)
		if t ^ 'Лес' and _'паук'.search then
			_'паук'.search = false
			p [[Паук не стал преследовать Гегеля.]]
			return
		end
	end;
	decor = [[Гегель находится внутри громады. Здесь темно, но света, который льется
сквозь {#дыры|отверстия} в стенах, достаточно для глаз кота. Спертый {#воздух|воздух} не нравится
Гегелю.]];
	way = { path{ 'Внутрь', 'логово' }, path { 'В лес', 'Лес' } };
}:disable():with {
	obj {
		nam = 'паутина';
		dsc = [[Выход в лес затянут {паутиной}.]];
		act = [[Выхода нет!]];
	}:disable();
	obj {
		nam = '#дыры';
		act = function(s)
			if seen 'паук' and idea then
				p [[Гегель в отчаянной попытке рванулся к одному из отверстий и протиснулся в него.]]
				p [[Успел!]]
				lifeoff 'паук'
				walkin ('Лес')
			else
				p [[В стенах и потолке Гегель видит небольшие отверстия.]];
			end
		end;
	};
	obj {
		nam = '#воздух';
		act = [[Гегель чувствует запах человека!!!... И кого-то еще...]];
	};
};

global 'hidden' (false)

obj {
	nam = 'паук';
	attack = false;
	search = false;
	dir = false;
	life = function(s)
		if seen 'паук' then
			enable_map = true
		end
		if player_moved() then
			if seen 'паук' and not hidden then
				s.search = true
				return
			end
			if s.search then
				place(s)
				s.attack = false
				return
			end
		end
		if seen 'паук' and not hidden then
			s.search = true
			p [[Паук готовится атаковать Гегеля!]]
			s.attack = true
			return true
		end

		if where(s) ^ 'инженерный отсек' then
			s.dir = true
			place(s, 'мостик')
		elseif where(s) ^ 'грузовой отсек' then
			if here() ^ 'грузовой отсек' and hidden then
				place(s, 'логово')
				p [[Паук ушел по направлению к выходу.]]
			elseif idea then
				s.dir = true
				place(s, 'логово')
			else
				s.dir = false
				place(s, 'мостик')
			end
		elseif where(s) ^ 'мостик' then
			if s.dir then
				place(s, 'грузовой отсек')
			else
				place(s, 'инженерный отсек')
			end
		elseif where(s) ^ 'логово' then
			if idea and s.dir then
				place(s, 'Внутри')
			else
				place(s, 'инженерный отсек')
			end
		elseif where(s) ^ 'Внутри' then
			s.dir = false
			place(s, 'логово')
		end
		if seen 'паук' then
			enable_map = true
			p [[Кот видит как из темноты выползает огромный паук!]]
			if not hidden then
				s.search = true
			end
			return true
		end
		if here() ^ 'логово' then
			p [[Тонкий слуг Гегеля уловил какой-то шорох.]];
			if where 'паук' ^ 'инженерный отсек' then
				enable_map = true
				p [[Шорох доносится с востока.]]
			elseif where 'паук' ^ 'грузовой отсек' then
				enable_map = true
				p [[Шорох доносится с запада.]]
			end
		end
--		print("spider at:", where(s))
		return
	end;
	dsc = function(s)
		if s.attack then
			p [[Гегель видит перед собой громадного {паука}.]];
		else
			if hidden then
				p [[Гегель видит, как в темноте двигается огромный {паук}.]];
			else
				p [[Гегель видит, как к нему приближается огромный {паук}.]];
			end
		end
	end;
	act = function(s)
		p [[Если бы Гегель умел терять сознание, он бы это сделал бы.]]
	end;
}

room {
	nam = 'логово';
	pic = show_map;
	title = 'Развилка';
	decor = [[Гегель оказался в помещении из которого, кроме пути наружу, есть два {#выходы|выхода}.]];
	way = { path { 'Запад', 'грузовой отсек' },
		path { 'Восток', 'инженерный отсек' },
		path { 'К выходу', 'Внутри' } };
} : with {
	obj {
		nam = '#выходы';
		act = [[Гегель чувствует запах человека... и не только...]];
	}
}

room {
	nam = 'грузовой отсек';
	pic = show_map;
	title = 'Грузовой отсек';
	decor = [[Гегель находится в длинном помещении, вдоль которого стоят массивные {#контейнеры|контейнеры}.]];
	onexit = function(s) hidden = false; end;
	way =  { path { 'В глубь', 'мостик' }, path { 'К выходу', 'логово' } };
}: with {
	obj {
		nam = '#контейнеры';
		act = function(s)
			if seen 'паук' then
				p [[Гегель не думает, что это хорошая идея -- осматривать контейнеры вместе с пауком.]]
				return
			end
			if hidden then
				p [[Гегель затаился в пустом контейнере.]]
				return
			end
			hidden = true
			p [[Гегель обнаружил пустой контейнер и спрятался в нем.]]
		end;
	}
}

room {
	nam = 'инженерный отсек';
	pic = show_map;
	title = 'Инженерный отсек';
	enter = function(s, f)
		if f ^ 'тоннель' then
			p [[Гегель провалился вниз и упал на холодный железный пол.]]
		end
	end;
	decor = [[Гегель находится в узком помещении, заставленном какими-то странными {#механизмы|механизмами}.]];
	way = { path { 'В глубь', 'мостик' }, path { 'К выходу', 'логово' } };
}: with {
	'паук';
	obj {
		nam = '#механизмы';
		act = [[Механизмы пугают Гегеля. Лучше держаться от них подальше.]];
	};
}

room {
	nam = 'мостик';
	pic = show_map;
	title = 'Мостик';
	decor = [[Гегель оказался в небольшой квадратной комнате. Кроме двух проходов на запад и на восток,
здесь есть закрытая {#дверь|дверь}.]];
	way = { path { 'Запад', 'грузовой отсек' },
		path { 'Восток', 'инженерный отсек' } },
}: with {
	obj {
		nam = '#дверь';
		act = function(s)
			if seen 'паук' then
				p [[Гегель чувствует запах человека за дверью, но паук мешает подойти к ней.]]
			else
				change_pl(pl)
				walk 'Дверь'
			end
		end;
	}
}
scene {
	nam = 'Дверь';
	decor = [[Гегель в отчаянной попытке рванулся к двери и принялся царапать ее когтями и громко мяукать.
Дверь оставалась закрытой.]];
	next = 'В кабине';
}

room {
	nam = 'В кабине';
	enter = function(s)
		_'паук'.search = false
		lifeon (s)
		p [[Петр был подавлен. Многообещающая ночная вылазка, которая началась с потрясающего артефакта в
виде потерпевшего крушения космического корабля, заканчивалась безвыходной ситуацией. Если не
сказать хуже. Петр сидел в кресле пилота и гадал, закрылся уже портал или нет. А если и не закрылся, то как выбраться
из ловушки? Вдруг, Петр услышал какой-то шум...]];
	end;
	life = function(s)
		if not seen 'кот2' then
			p [[Петр слышит какие-то {#звуки|звуки} из-за двери.]]
		else
			p [[Петр слышит глухие {#звуки|удары} в закрытую дверь.]];
		end
	end;
	decor = function(s)
		p [[Петр находится в кабине пилота. Сквозь узкие {#окна|окна} в кабину проникает
кровавый свет {#закат|заката}. {#приборы|Приборы} разбиты.]]
		if seen '#скелет' then
			p [[В одном из двух кресел пилотов сидит {#скелет|скелет}.]]
		else
			p [[{#кресло|Кресло} в котором сидел скелет -- свободно.]]
		end
		p [[{#дверь|Дверь} в кабину заперта.]];
	end;
}: with {
	obj {
		nam = '#закат';
		act = [[Скоро станет совсем темно... Что будет тогда?]];
	};
	obj {
		nam = '#окна';
		act = [[Петр так и не смог их разбить.]];
	};
	obj {
		nam = '#приборы';
		act = [[В более подходящее время, Петру было бы ужасно интересно изучить их. Но не сейчас.]];
	};
	obj {
		nam = '#скелет';
		used = function(s, w)
			if w ^ 'мобильник' then
				return [[Петр не хочет пачкать мобильник.]]
			elseif w ^ 'пропуск' then
				if not idea or not seen '#отверстие' then
					p [[Зачем беспокоить скелет?]]
					return
				end
				remove(s)
				enable '#кресло'
				return [[Петр толкнул карточкой скелет и он упал с кресла, рассыпавшись на кости.]];
			end
			return false
		end;
		act = function(s)
			p [[Судя по всему, скелет сидит в этом кресле очень давно.]]
			p [[Петр не хочет трогать его руками.]]
			if idea then
				p [[Над креслом Петр видит небольшое отверстие.]]
				enable '#отверстие'
			end
		end;
	};
	obj {
		nam = '#отверстие';
		dsc = [[В стене у потолка находится {отверстие}.]];
		act = function(s)
			p [[Отверстие достаточно для того, чтобы в него пролез кот.]]
			p [[Но слишком высоко, чтобы до него дотянулся Петр.]]
		end;
	}:disable();
	obj {
		nam = '#кресло';
		act = function(s)
			p [[С кресла Петр может добраться до отверстия!]];
			p [[Петр встал на кресло и осмотрел отверстие.]];
			p [[Ну что же, можно попробовать!]]
			if idea == true then
				idea = 2
			end
		end;
	}:disable();
	obj {
		nam = '#дверь';
		act = function(s)
			if not seen '#глазок' then
				enable '#глазок'
				p [[В двери расположен глазок.]]
			else
				if _'#глазок':actions() == 0 then
					p [[Надо бы посмотреть, что за дверью...]]
				elseif seen 'кот2' then
					p [[Открыть дверь? Ну уж нет!]]
				else
					if _'#звуки':actions() == 0 then
						p [[Петру не хочется рисковать. Где-то там бродит опасная тварь!]]
						return
					end
					p [[Петр приоткрыл дверь ровно на столько, чтобы
напуганный Гегель влетел и уцепился в его штанину. Краем зрения Петр увидел очертания мерзких
лап паука, и с силой захлопнул тяжелую дверь. Снаружи послышался глухой удар.]];
					place 'кот2'
					return
				end
			end
		end;
	};
	obj {
		nam = '#глазок';
		dsc = 'В двери расположен {глазок}.';
		act = function(s)
			if not seen 'кот2' then
				p [[Кажется, паука не видно...]]
			else
				p [[Петр видит волосатые лапы огромного паука.]]
			end
		end;
	}:disable();
	obj {
		nam = '#звуки';
		act = function(s)
			if not seen 'кот2' then
				p [[Кажется, это Гегель? Надо открыть дверь! Но там же эта тварь!!!]];
			else
				p [[Сильная тварь.]]
			end
		end;
	};
}

global 'idea' (false)

obj {
	nam = 'кот2';
	disp = 'Гегель';
	dsc = function(s)
		if idea == 4 then
			p [[{Гегель} с удивлением рассматривает на себе смартфон Петра.]]
		else
			p [[{Гегель} вцепился в штанину Петра.]];
		end
	end;
	inv = [[Муррррр...]];
	use = function(s, w)
		if w ^ '#отверстие' then
			lifeoff(here())
			change_pl(cat)
			take 'мобильник'
			enable 'паутина'
			walk 'В лаз'
			return
		end
		return [[Гегелю это не интересно.]]
	end;
	act = function(s)
		if idea == 4 then
			take(s)
			p [[Петр взял Гегеля в руки.]]
		else
			p [[Петр почесал кота за ухом.^-- Зачем же ты пришел сюда, дурачок? Мы оба пропадем, если не придумаем что-нибудь.]];
		end
	end;
}
scene {
	nam = 'В лаз';
	decor = [[Человек нагло и грубо толкает Гегеля в дыру. Опасность! Опасность!
Но человеку все-равно! Человек не ценит Гегеля! Ну что же, так тому и быть... Гегель
перестал сопротивляться и полез в узкий и темный тоннель...]];
	next = 'тоннель';
}

room {
	nam = 'тоннель';
	title = 'Тоннель';
	steps = 0;
	enter = function(s, f)
		s.steps = s.steps + 1
		if f == s then
			if s.steps % 2 == 0 then
				p [[Гегель прополз еще немного.]]
			else
				p [[Гегель снова ползет по трубе.]]
			end
		end
		if s.steps > 6 then
			disable '#вперед'
			enable '#вниз';
			p [[Гегель видит выход из тоннеля!]]
		end
	end;
	decor = [[Гегель ползет по длинной узкой трубе.]];
	way = {
		path { '#вперед', 'Вперед', 'тоннель' };
		path { '#вниз', 'Вниз', 'инженерный отсек' }:disable();
	};
}:with {

}

scene  {
	nam = 'happyend';
	title = 'Немного позже';
	decor = { [[-- Но я не военный и не подчиняюсь...^
-- Молчааать, когда с вами разговаривает старший по званию! -- рявкнул генерал Иволгин -- Александр Александрович, объясните ему...]],
[[^-- Видите ли, Петр Геннадьевич, с формальной точки зрения -- вы правы. Но если выбирать между закрытием НИИ и вашим увольнением,
то я буду вынужден...^
-- Мне все понятно -- мрачно сказал Петр -- можете не продолжать.]],
[[-- Петр Геннадьевич, ведь вас никто не гонит! Просто генерал просит проявлять дисциплину -- принялся снова уговаривать Петра директор.^
-- Отставить! -- снова рявкнул генерал -- Вы рисковали не только своей жизнью, но и судьбой всего проекта! Вы понимаете это?]],
[[-- Да, понимаю -- сдался Петр.]];};
	next = 'realend'

}
room {
	nam = 'realend';
	title = 'Конец';
	noinv = true;
	decor = function()
		p [[Он перестал слушать генерала и пока тот что-то остервенело кричал,
Петр краем глаза смотрел в окно, перебирая в памяти события последних часов.^
Тут что-то теплое коснулось его ног.
Он рассеяно посмотрел вниз и увидел там Гегеля, который снова просил поесть.^
Петр сел на корточки (в этот момент генерала почти хватил удар) и принялся поглаживать
теплого и лохматого кота, который на время забыл про еду и принялся урчать в знак
благодарности...]]
		pn ()
		pn ()
		pn (fmt.r(fmt.em("Петр Косых^апрель 2017^Специально для ИНСТЕДОЗ #5")))
		pn ()
		pn (fmt.c("{@restart|ВЕРНУТЬСЯ К ЖУРНАЛУ}"))
	end;
}

function init()
	take 'пропуск'
	take 'мобильник';
end
